---
title: Frontend architecture
---

# Frontend architecture

## Next.js

Plush.bike is a [Next.js](https://nextjs.org/) site that is then compiled to static HTML files.
[Next.js](https://nextjs.org/) handles build config, routing, etc.

## Typescript

Plush.bike is written in [Typescript](https://www.typescriptlang.org/). This allows for improved autocompletion and type saftey.

## Redux Toolkit

State management is handled by [Redux Toolkit](https://redux-toolkit.js.org/).

## Apollo Client

Plush.bike uses a GraphQL API. [Apollo Client](https://www.apollographql.com/docs/react/) handles calling this API and caching the result. 

## GraphQL Codegen

[GraphQL Codegen](https://www.graphql-code-generator.com/) use the GraphQL schema to generate [Typescript](https://www.typescriptlang.org/) definitions for all GraphQL queries and mutations.
Run `graphql:codegen` to generate [Typescript](https://www.typescriptlang.org/) definitions.

## Tailwind CSS

Styling is handled by [Tailwind CSS](https://tailwindcss.com/).

## Headles UI

Accessible React components are created using [Headless UI](https://headlessui.dev/).

## Tailwind UI

Design is based off of [Tailwind UI](https://tailwindui.com/).

## Testing Library

Unit testing is handled by [Jest](https://jestjs.io/) and [Testing Libray](https://testing-library.com/).

## Icons

All of the [Zondicon](https://www.zondicons.com/) icons are available for use.

## ESLint

Linting is handled by [ESLint](https://eslint.org/).

## Deployer

Deployment is handled by [Deployer](https://deployer.org/).
